diff --git a/app/scripts/app.js b/app/scripts/app.js
index 517fa12..7508f15 100644
--- a/app/scripts/app.js
+++ b/app/scripts/app.js
@@ -326,7 +326,7 @@ const realApp = angular.module('realHomeuiApp', [module.name, mqttServiceModule,
         //.........................................................................
         function configRequestMaker(mqttClient, ConfigEditorProxy, webuiConfigPath, errors, whenMqttReady, uiConfig) {
             return function (loginData) {
-                if (loginData.host && loginData.port) {
+                if (loginData.host) {
                     var clientID = 'contactless-' + randomString(10);
                     if (mqttClient.isConnected()) {
                         mqttClient.disconnect();
@@ -369,7 +369,7 @@ const realApp = angular.module('realHomeuiApp', [module.name, mqttServiceModule,
             port: 18883
         };
 
-        if(!$window.localStorage.host || !$window.localStorage.port) {
+        if(!$window.localStorage.host && !$window.localStorage.port) {
             $window.localStorage.setItem('host', demoLoginData.host)
             $window.localStorage.setItem('port', demoLoginData.port)
         }
diff --git a/app/scripts/components/loginForm/loginForm.controller.js b/app/scripts/components/loginForm/loginForm.controller.js
index 578f5f5..b1f67c7 100644
--- a/app/scripts/components/loginForm/loginForm.controller.js
+++ b/app/scripts/components/loginForm/loginForm.controller.js
@@ -39,7 +39,7 @@ class LoginFormCtrl {
     if (port) {
       this.port = port;
     } else {
-      this.port = '18883';
+      this.port = '';
     }
     if (useCredentials) {
       this.useCredentials = useCredentials;
diff --git a/app/scripts/components/loginForm/loginForm.html b/app/scripts/components/loginForm/loginForm.html
index d2bcfd4..7362624 100644
--- a/app/scripts/components/loginForm/loginForm.html
+++ b/app/scripts/components/loginForm/loginForm.html
@@ -19,7 +19,7 @@
 
                     <div class="col-sm-10">
                         <input type="text" class="form-control" id="loginPort" name="port" ng-model="$ctrl.port"
-                               required>
+                               >
                     </div>
                 </div>
                 <div class="form-group">
diff --git a/app/scripts/services/mqttService.js b/app/scripts/services/mqttService.js
index 1e1d011..1a5d761 100644
--- a/app/scripts/services/mqttService.js
+++ b/app/scripts/services/mqttService.js
@@ -74,10 +74,18 @@ function mqttClient($window, $rootScope, $timeout, $q, topicMatches, mqttConnect
       messageDigestTimer = null,
       retainReady = $q.defer(),
       retainIsDone = false,
-      retainHackTopic = '';
+      retainHackTopic = '',
+      origSSL = false,
+      origPort = '';
 
   if($window.localStorage['prefix'] === 'true')
     globalPrefix = '/client/' + $window.localStorage['user'];
+  if($window.location.protocol === 'https:') {
+  	origSSL = true;
+  }
+  if($window.location.port !== "") {
+  	origPort = $window.location.port;
+  }
 
   //...........................................................................
   function reconnectAfterTimeout() {
@@ -133,6 +141,21 @@ function mqttClient($window, $rootScope, $timeout, $q, topicMatches, mqttConnect
       connectOptions.userName = user;
       connectOptions.password = password;
     }
+    if(origSSL) {
+      connectOptions.useSSL = true;
+    }
+
+    if (port === "") {
+      if(origPort !== "") {
+        port = origPort;
+      } else {
+        if (origSSL) {
+          port = "443";
+        } else {
+          port = "80";
+        }
+      }
+    }
 
     id = clientid;
 
